function [tout5, hip_img, actual_reference, bestReferenceSlice, best_fitn, best_ref, fitn] = ...
    bestReferenceSliceSelection(sum_variance,calculate_local, fitnesses, REFERENCES, ...
    ORIG_HIPPO_REGION, BIGGEST_REF_IMAGE_SIZE, show_output, Iorig, orig_width_target, ...
    out_dir_name, image_name, timestamp, I1show)


tic
%% BEST REFERENCE SLICE SELECTION
%these below are for passing from std to trust factor (trust factor: degree
%of confidence of the local registration)
MIN_TRUST = 0.3;%0.25;
MAX_TRUST = 0.7;%0.75;
MIN_STD = 0.5;
MAX_STD = 1.5;
NORM_FACTOR = 10;
%calculate reliability measure and fitnesses
%it's a linear relation
sum_variance = (sum_variance/sum(calculate_local))*NORM_FACTOR;
trust_roi = (sum_variance-MIN_STD)/((MAX_STD-MIN_STD)/(MAX_TRUST-MIN_TRUST)) + MIN_TRUST;
if trust_roi < MIN_TRUST
    trust_roi = MIN_TRUST;
elseif trust_roi > MAX_TRUST
    trust_roi = MAX_TRUST;
end
fitn = (1-trust_roi)*fitnesses(1,:)+trust_roi*fitnesses(2,:);
%     % if show_output > -1
%     %     fprintf(f,'TRUST: %f\n',trust_roi);
%     %     for ref = 1:siz_ref(1)
%     %         fprintf(f,'%d: %f\n',REFERENCES(ref),fitn(ref));
%     %     end
%     % end
%     fitn = fitnesses(1,:);
[best_fitn best_ref] = min(fitn); %find best reference atlas
bestReferenceSlice=REFERENCES(best_ref);
actual_reference = sprintf('reference%i',REFERENCES(best_ref));
best_orig_hippo = reshape(ORIG_HIPPO_REGION(best_ref,:,:),4,3);

% do operations on the best:
% best_orig_hippo contains the coordinates of the best hippocampus. From
% here you can obtain the image of the hippocampus in the original image.

if show_output > 0
    fprintf(1,'Saving the hippocampus...\n');
end

% %try to select the original hippocampus reference
% ref_hippo = HIPPO_REGION.(actual_reference);
% %add offset to enlarge the roi
% ref_hippo = ref_hippo + MY_OFFSET;
% ref_hippo = [ref_hippo(1) ref_hippo(2) 1; ref_hippo(1) ref_hippo(4) 1; ref_hippo(3) ref_hippo(2) 1; ref_hippo(3) ref_hippo(4) 1];
% ref_hippo(:,1) = ref_hippo(:,1) + (BIGGEST_REF_IMAGE_SIZE(2) - orig_width_ref(best_ref)) / 2.0;
% ref_orig_to_draw = [ref_hippo(1,:);ref_hippo(2,:);ref_hippo(4,:);ref_hippo(3,:);ref_hippo(1,:)];

%reproject to original image
% Iorig = imread(source_image_name); %load original name
% orig_size = size(Iorig);
ratio = repmat([size(Iorig,2), size(Iorig,1), 1]./[orig_width_target,BIGGEST_REF_IMAGE_SIZE(1),1],5,1);
%if during the local registration there has been a movement, enlarge roi
% local_tr = LOCAL_TRANSFORM.(actual_reference);
% if local_tr(2) < 0 %for y
%     best_orig_hippo(1:2,1) = best_orig_hippo(1:2,1) + local_tr(2)/2; %the /2 is to avoid too big movements
% else
%     best_orig_hippo(3:4,1) = best_orig_hippo(3:4,1) + local_tr(2)/2;
% end
% if local_tr(1) < 0 %and x
%     best_orig_hippo([1 3],2) = best_orig_hippo([1 3],2) + local_tr(1)/2;
% else
%     best_orig_hippo([2 4],2) = best_orig_hippo([2 4],2) + local_tr(1)/2;
% end
orig_to_draw = [best_orig_hippo(1,:);best_orig_hippo(2,:);best_orig_hippo(4,:);best_orig_hippo(3,:);best_orig_hippo(1,:)];
if show_output > 2
    figure('Name','Hippocampus','NumberTitle','Off');imshow(I1show);
    hold on
    line(orig_to_draw(:,1),orig_to_draw(:,2));
end
best_orig_hippo(:,1) = best_orig_hippo(:,1) - (BIGGEST_REF_IMAGE_SIZE(2) - orig_width_target) / 2.0; %to remove the enlargement of image
% orig_to_draw = [best_orig_hippo(1,:);best_orig_hippo(2,:);best_orig_hippo(4,:);best_orig_hippo(3,:);best_orig_hippo(1,:)];
big_to_draw = [best_orig_hippo(1,:);best_orig_hippo(2,:);best_orig_hippo(4,:);best_orig_hippo(3,:);best_orig_hippo(1,:)].*ratio;
% [big_to_draw ratio]
minx = min(big_to_draw(:,1));
miny = min(big_to_draw(:,2));
width = max(big_to_draw(:,1))-minx;
height = max(big_to_draw(:,2))-miny;
% [minx miny width height]
hip_img = imcrop(Iorig,[minx miny width height]);
%
% size(hip_img)
% figure,imshow(hip_img)

if show_output > -1
    hippo_filename = sprintf('%s/%s_BRSS_ref%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI
    imwrite(hip_img, hippo_filename,'png');
end

if show_output > 2
    figure('Name','Original Hippocampus','NumberTitle','Off'); imshow(Iorig);
    hold on
    line(big_to_draw(:,1),big_to_draw(:,2));
end

clear Iorig

if show_output > 0
    fprintf(1,'Best Reference Slice Selection complete.\n');
end
tout5 = toc;