function res = classifyWindowTexture(im, mask_in)

%     addpath('data')
%     addpath('randomforest\')
%     addpath('randomforest\randomforest-matlab\RF_Class_C\')
    load rf_model_onlytexture
    NUMBER_OF_POINTS_PER_PART = 12  ;
    WIN_SIZES = [30, 90, 150, 210,300];
    load('std_stand','std_stand')
    load('mean_stand','mean_stand')
    load('um', 'um')
    load('ustd','ustd')
    im_in = im.*mask_in;
    im_out = im.*(1-mask_in);
    ANALYZED_POINTS = [0,0];
    CORRECT_POINTS = [0,0];
    in_points = zeros(NUMBER_OF_POINTS_PER_PART,2);
    out_points = zeros(NUMBER_OF_POINTS_PER_PART,2);
    in_class = zeros(NUMBER_OF_POINTS_PER_PART,1);
    out_class = zeros(NUMBER_OF_POINTS_PER_PART,1);
    
    temp=double(im);
    m=mean(temp(:));
    st=std(temp(:));
    im=(temp-m)*ustd/st+um;
    %     im=reshape(im,rows,colums)';
    im=uint8(im);
%     InputImage = adapthisteq(im); %If we change this kind of equalization for the classical one the result will be much more noisy
%     InputImage(InputImage > 175) = 255;
%     InputImage(InputImage < 40) = 0;
%     InputImageNew = adapthisteq(InputImage);
%     J=InputImageNew;
%     level = graythresh(J);
%     BW_global = im2bw(J,level);
%     BW_final = 1-BW_global;
%     BW_final2 = BW_final;
%     CC = bwconncomp(BW_final2,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
%     numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
%     [ordered,idx] = sort(numPixels,'descend');
%     con_component=4;
%     indexes = idx(1:con_component);
%     for pp=1:length(numPixels)
%         BW_final2(CC.PixelIdxList{pp}) = 255*ismember(pp,indexes);
%     end

%     number_of_pixels = size(im,1)*size(im,2);
%     [COUNTS,X] = imhist(im);
    [rows, columns, levels] = size(im);


    while sum(ANALYZED_POINTS) < NUMBER_OF_POINTS_PER_PART*2
        do_it = 0;
        %% %%%%%%%%%%%%%%%%%%%%%%CREATION OF THE INPUT PATTERNS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        input_pattern=[];
        y = ceil(rand*columns);
        x = ceil(rand*rows);
        if mask_in(x,y) == 1 && ANALYZED_POINTS(1) < NUMBER_OF_POINTS_PER_PART
            ANALYZED_POINTS(1) = ANALYZED_POINTS(1) + 1;
            in_points(ANALYZED_POINTS(1),:) = [y x];
            do_it = 1;
        end
        if mask_in(x,y) == 0 && ANALYZED_POINTS(2) < NUMBER_OF_POINTS_PER_PART
            ANALYZED_POINTS(2) = ANALYZED_POINTS(2) + 1;
            out_points(ANALYZED_POINTS(2),:) = [y x];
            do_it = 1;
        end
        if ~do_it
            continue;
        end
%         y = round(y); x= round(x);
%         tic
        for w = 1:length(WIN_SIZES)

            if (round(x-WIN_SIZES(w)/2) < 1)
                value1=1;
            else
                value1=x-WIN_SIZES(w)/2;
            end;
            if (round(x+WIN_SIZES(w)/2) > size(im,1))
                value2=size(im,1);
            else
                value2=x+WIN_SIZES(w)/2;
            end;
            if (round(y-WIN_SIZES(w)/2) < 1)
                value3=1;
            else
                value3=y-WIN_SIZES(w)/2;
            end;
            if (round(y+WIN_SIZES(w)/2) > size(im,2))
                value4=size(im,2);
            else
                value4=y+WIN_SIZES(w)/2;
            end;
            window = im(round(value1):round(value2),round(value3):round(value4));

            h = imhist(window,16);
            h=h/sum(h);
            cv = std2(window)/mean2(window);
            skew = skewness(h);
            curt = kurtosis(h);
            ener = sum(h/sum(h).*h/sum(h));
            entr = entropy(h);
            G = graycomatrix(window,'symmetric', true, 'Offset', [1,1],'NumLevels',16);
            feat=graycoprops(G);
            input_pattern = [input_pattern mean2(window), std2(window), cv, skew, curt, ener, entr, feat.Contrast,feat.Correlation,feat.Energy,feat.Homogeneity];
        end


    %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        % TEST WITH THIS POINT
        % Removing Nan
        input_pattern(isnan(input_pattern)) = 0;
        input_pattern = (input_pattern - mean_stand)./std_stand;
%             output = svmpredict(1, input_pattern, svm_model, '-b 1');
        output = classRF_predict(input_pattern, rf_model);
        if mask_in(x,y) == 1
            in_class(ANALYZED_POINTS(1)) = output;
        else
            out_class(ANALYZED_POINTS(2)) = output;
        end
        if (output == 1 && mask_in(x,y) == 1)
            CORRECT_POINTS(1) = CORRECT_POINTS(1) + 1;
        end
        if (output == 2 && mask_in(x,y) == 0)
            CORRECT_POINTS(2) = CORRECT_POINTS(2) + 1;
        end


    end
    res = sum(CORRECT_POINTS(1))/sum(ANALYZED_POINTS(1))>0.5; %count only the inside one, i think the outside ones are (almost) always good
%     if ~res
%         COLOR = ['r','g'];
%         figure;
%         subplot(2,1,1)
%         imshow(im_in);
%         hold on
%         for i=1:NUMBER_OF_POINTS_PER_PART
%             filledCircle(in_points(i,:),5,20,COLOR(in_class(i)));
%         end
%         subplot(2,1,2)
%         imshow(im_out);
%         hold on
%         for i=1:NUMBER_OF_POINTS_PER_PART
%             filledCircle(out_points(i,:),5,20,COLOR(out_class(i)));
%         end
%         waitforbuttonpress
%         close(gcf);
%     end
end