function [tout2, res_img, I1,BIGGEST_REF_IMAGE_SIZE,orig_width_target] ...
    = extractExternalContour(extract_contours,show_output,ELAB_CONT_FOLDER,image_name,ELAB_FOLDER,SOURCE_FOLDER,BIGGEST_REF_IMAGE_SIZE)

tic
source_image_name = sprintf('%s/%s.jpg',SOURCE_FOLDER,image_name);
if extract_contours > 0 %search in images/source, extract contours and put it in elab_cont, resize image and put it in elab
    %     tmpRatio = size(Iorig,1)/BIGGEST_REF_IMAGE_SIZE(1); %keep the ratio and the height of image (255)
    %     res_img = imresize(Iorig, [BIGGEST_REF_IMAGE_SIZE(1), size(Iorig,2)/tmpRatio],'bilinear'); %store the original image resized
    if show_output > 0
        fprintf(1,'Start Contour Extraction...\n');
    end
    image_filename = sprintf('%s/%s_cont',ELAB_CONT_FOLDER,image_name); %without extension
    entire_image_filename = sprintf('%s/%s',ELAB_FOLDER,image_name); %without extension
    if isempty(findstr(entire_image_filename,'synthetic'))
        command = ['Extract_External_Contour.exe ', source_image_name, ' ', image_filename, ' ', entire_image_filename];
    else
        command = ['Extract_External_Contour_Synth.exe ', source_image_name, ' ', image_filename, ' ', entire_image_filename];
    end;
    %     % Example of command use:
    % Extract_External_Contour.exe (program)
    % images/source/A030009H04Rik_117.jpg (original image in high resolution)
    % images/elab_cont/A030009H04Rik_117_cont (output resized binarized image)
    % images/elab/A030009H04Rik_117 (output original image resized in gray scale)
    system(command); %execute external command
    image_filename = strcat(image_filename, '.png');
    entire_image_filename = strcat(entire_image_filename, '.png');
    %     orig_img = imread(source_image_name);
    %     imwrite(res_img,entire_image_filename,'png');
else %else, just set image_filename
    image_filename = sprintf('%s/%s_cont.png',ELAB_CONT_FOLDER,image_name);
    entire_image_filename = sprintf('%s/%s.png',ELAB_FOLDER,image_name);
    if exist(image_filename,'file') == false
        error(strcat('Source file (',image_filename,') is not in the correct folder (', ELAB_CONT_FOLDER ,'). Elaboration stopped.'));
    end
    if exist(entire_image_filename,'file') == false
        error(strcat('Source file (',entire_image_filename,') is not in the correct folder (', ELAB_FOLDER ,'). Elaboration stopped.'));
    end
end

res_img = im2double(imread(entire_image_filename)); %it is the original image resized and in graylevels



% at this point in image_filename there is the name of the image to
% register
% I1 will be the 2D/3D image which is affine transformed
% I2 will be he second 2D/3D image which is used to calculate the registration error
I1=im2double(imread(image_filename));
% CONVERT TO GRAY SCALE IF NEEDED --> IT IS MUCH MORE FAST
if (size(I1,3)>1)
    I1 = rgb2gray(I1);
end;

%if the target image is larger than the largest reference, change it.
orig_width_target = size(I1, 2);
if size(I1, 2) > BIGGEST_REF_IMAGE_SIZE(2)
    BIGGEST_REF_IMAGE_SIZE(2) = size(I1, 2);
else %fix width
    I1 = fix_image_width(I1,BIGGEST_REF_IMAGE_SIZE(2),0);
end

tout2 = toc; % time: contour extraction