function v = JointEntropy(x, y)
% Joint entropy of two vectors
% Written by Mo Chen (mochen@ie.cuhk.edu.hk). March 2009.
assert(length(x) == length(y));

x = x(:);
y = y(:);

n = length(x);

x_unique = (0:15);%unique(x);
y_unique = (0:15);%unique(y);

% check the integrity of y
% if length(x_unique) ~= length(y_unique)
%     error('number of states of inputs are not equal.');
% end;

c = 16;%max([length(x_unique) length(x_unique)]);

% distribution of y and x
Ml = double(repmat(x,1,c) == repmat(x_unique,n,1));
Mr = double(repmat(y,1,c) == repmat(y_unique,n,1));

M = Ml'*Mr/n;
v = -sum( M(:) .* log2( M(:) + eps ) );
