﻿#ifndef PIXMAPWIDGET_HPP
#define PIXMAPWIDGET_HPP

#include <QLabel>
#include <QString>
#include <QScrollArea>

class QPixmap;
class QScollArea;

namespace ofeli
{

class PixmapWidget : public QLabel
{
    Q_OBJECT

public :

    PixmapWidget(QWidget *parent=0 );
    void set_qimage0(const QImage& qimage1);
    void set_qimage(const QImage& qimage1);
    void set_doWheelEvent(bool doWheelEvent1);
    void set_zoomFactor(float zoomFactor1);
    float get_zoomFactor() const;
    int getPixWidth() const;
    int getPixHeight() const;
    int get_xoffset() const;
    int get_yoffset() const;
    void set_hasText(bool hasText1);
    const QImage& get_qimage() const;
    void set_text(QString text1);

public slots :

    void setZoomFactor( float );


signals :

    void zoomFactorChanged( float );


protected :

    void paintEvent(QPaintEvent*);
    void wheelEvent(QWheelEvent* );


private :

    QImage qimage;
    float zoomFactor;
    int xoffset;
    int yoffset;
    bool hasText;
    QString text;
    bool doWheelEvent;
};

}

#endif // PIXMAPWIDGET_HPP

//! \class ofeli::PixmapWidget
//! The class PixmapWidget is a Qt4 widget to display fastly an image (function drawPixmap in a PaintEvent is faster than function setPixmap) and gives the possibility to zoom with a mouse wheel event in function of the position of the cursor.
//! Thanks to Johan Thelin. This class is based on this example http://qt4.digitalfanatics.org/articles/zoomer.html.
