function [xmin,tfxmin] = optimizationWithPSO(n_points, ...
    target, outer_shift_cart_op, movements_min, movements_max, movements_mean, penalties, generations, populationSize)

de_find(0,target,outer_shift_cart_op,movements_min, movements_max, movements_mean, penalties);

psoOptions = get_psoOptions;
psoOptions.Flags.ShowViz = 0;
    psoOptions.Flags.Neighbor = 0;

psoOptions.Vars.SwarmSize = populationSize; % 80
psoOptions.Vars.Dim = n_points*2;
psoOptions.Vars.Iterations = generations; %250
psoOptions.Vars.ErrGoal = 1;

psoOptions.SParams.c1 = 2.05;
psoOptions.SParams.c2 = 1.75;
psoOptions.SParams.w_start = 1.0;
psoOptions.SParams.w_end = 0.2;
psoOptions.SParams.Vmax = 1.0;
psoOptions.SParams.Nhood = 1;

psoOptions.Obj.f2eval = 'de_find';
psoOptions.Obj.GM = -inf;% (5*n_points + 20*(n_points-1));
psoOptions.Obj.lb = 0;
psoOptions.Obj.ub = 1;

psoOptions.Terminate.Iters = 1;
psoOptions.Terminate.Err = 1;

psoOptions.Save.Interval = 1;
psoOptions.Disp.Interval = 0; %display results frequency
psoOptions.Disp.Footer = 1;
psoOptions.Disp.Progress = 1;

[tfxmin xmin, Swarm, HistFDG] = pso_proposed(psoOptions);