function [xmin,tfxmin] = optimizationWithSA(n_points, ...
    target, outer_shift_cart_op, movements_min, movements_max, movements_mean, penalties, generations, populationSize)

de_find(0,target,outer_shift_cart_op,movements_min, movements_max, movements_mean, penalties);
psoOptions.Vars.SwarmSize = populationSize; %80
psoOptions.Vars.Iterations = generations; %250
options.Verbosity = 0;
options.StopTemp = 1e-12;
options.InitTemp = 1.5;
options.Generator = @(x) (x+0.05*randn(1,n_points*2));
options.MaxEvals = psoOptions.Vars.SwarmSize * psoOptions.Vars.Iterations;
tfxmin = 800;
for i=1:10
    [xmint tfxmint] = anneal(@(x)de_find(x),rand(1,n_points*2),options);
    %         FEVAL_CALLS
    if tfxmint < tfxmin
        xmin = xmint;
        tfxmin = tfxmint;
    end;
end;
