function [tout9, roi_points, roi_pointsdg, roi_points_out, roi_pointsdg_out] = ...
    outputLocalization(show_output, modelca, modeldg, modelca_out, modeldg_out, ...
    output_hippo_bound, referenceToUse, out_dir_name, image_name, REFERENCES, timestamp, ...
    hip_img, f, modelsToUse, target, best_ref)

tic
%% OUTPUT LOCALIZATION
if show_output > 0
    fprintf(1,'Saving results of localization...\n');
end
if strcmp(modelsToUse,'morePoints')
    n_points = length(modelca);
    n_points_dg = length(modeldg);
end;
ratio = size(hip_img)./size(target);
ratio = [ratio(2) ratio(1)];
roi_points = ceil(repmat(ratio,n_points,1).*modelca);
roi_pointsdg = ceil(repmat(ratio,n_points_dg,1).*modeldg);
roi_points_out = ceil(repmat(ratio,n_points,1).*modelca_out);
roi_pointsdg_out = ceil(repmat(ratio,n_points_dg,1).*modeldg_out);

xmin = min([roi_pointsdg_out(:,1); roi_points_out(:,1); roi_pointsdg(:,1); roi_points(:,1)])-output_hippo_bound;
ymin = min([roi_pointsdg_out(:,2); roi_points_out(:,2); roi_pointsdg(:,2); roi_points(:,2)])-output_hippo_bound;
w = max([roi_pointsdg_out(:,1); roi_points_out(:,1); roi_pointsdg(:,1); roi_points(:,1)]) - xmin+output_hippo_bound*2;
h = max([roi_pointsdg_out(:,2); roi_points_out(:,2); roi_pointsdg(:,2); roi_points(:,2)]) - ymin+output_hippo_bound*2;
loc_hip = imcrop(hip_img, [xmin ymin w h]);
if (show_output > -1) && (referenceToUse == 0)
    loc_filename = sprintf('%s/%s_loc_ref%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref), timestamp);
    imwrite(loc_hip,loc_filename,'png');
end

if show_output > 0
    h = figure('Name','Hippocampus Localization','NumberTitle','off');
    imshow(hip_img)
    hold on
    line(roi_points(:,1),roi_points(:,2),'Color','y','LineWidth',4);
    line(roi_pointsdg(:,1),roi_pointsdg(:,2),'Color','r','LineWidth',4);
    hold on, plot(roi_points(:,1),roi_points(:,2),'r*')
    hold on, plot(roi_pointsdg(:,1),roi_pointsdg(:,2),'y*')
    line(roi_points_out(:,1),roi_points_out(:,2),'Color','y','LineWidth',3,'LineStyle',':');
    line(roi_pointsdg_out(:,1),roi_pointsdg_out(:,2),'Color','r','LineWidth',3,'LineStyle',':');
    tmp_filename = sprintf('%s/%s_onmodel_ref%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref), timestamp);
    saveas(h,tmp_filename,'png');
end

if show_output > -1
    fprintf(f,'DG model\n');
    for i = 1:n_points_dg
        fprintf(f,'%d %d\n',roi_pointsdg(i,1),roi_pointsdg(i,2));
    end
    fprintf(f,'CA model\n');
    for i = 1:n_points
        fprintf(f,'%d %d\n',roi_points(i,1),roi_points(i,2));
    end
    fprintf(f,'External DG model\n');
    for i = 1:n_points_dg
        fprintf(f,'%d %d\n',roi_pointsdg_out(i,1),roi_pointsdg_out(i,2));
    end
    fprintf(f,'External CA model\n');
    for i = 1:n_points
        fprintf(f,'%d %d\n',roi_points_out(i,1),roi_points_out(i,2));
    end
    fclose(f);
end

tout9 = toc; %time: output localization