
function [] ...
    = performStatisticalTests(allResultsSegmentation, segmentationMethods, ...
    fileResultsLocalizationDG, fileResultsLocalizationCA, folder, metaheuristic, ...
    NUMBER_OF_IMAGES, NUMBER_OF_TESTS,performSegmentation)

global databaseOfMethods;

metricToTest = {'DSC'};
localizationProblem = 0;% 0-> minimization problem, 1 -> maximization problem
segmentationProblem = 1;% 0-> minimization problem, 1 -> maximization problem
significanceLevel = 0.01;
saveFigures = 0; %save Figures: Histograms, Q-Q plots,...?
segmentationResultsFile = 'segmentationResults';
minimumAllowedNumberOfRuns = 5;

numberValues = NUMBER_OF_IMAGES*NUMBER_OF_TESTS;
% If there's only one method avoid this step
if (size(metaheuristic,2) == 1)
    fprintf('Only one metaheuristic has been used during localization: %s\n',char(metaheuristic{1}));
    fprintf('Note: if the segmentation method does not need localization this metaheuristic could have not been used\n');
else
    %% Localization phase
    fname = strcat('./statisticalTests/inputParameters.txt');
    fidParametersFile = fopen(fname, 'w+');
    parametersFile=textscan(fidParametersFile,'%s','delimiter','\n');
    parametersFile{1}(1) = {strcat(folder,fileResultsLocalizationDG,'.txt')}; % input file
    parametersFile{1}(2) = {localizationProblem}; % 0-> minimization problem, 1 -> maximization problem
    %     parametersFile{1}(4) = {'1'}; % number of benchmark functions -> in this case all images are considered as only one big image
    parametersFile{1}(3) = {significanceLevel};
    parametersFile{1}(4) = {NUMBER_OF_IMAGES}; % number of benchmark functions -> in this case every image is considered as a benchmark funct.
    parametersFile{1}(5) = {saveFigures};
    parametersFile{1}(6) = {strcat(folder,fileResultsLocalizationDG,'_output.txt')}; % output file
    parametersFile{1}(7) = {minimumAllowedNumberOfRuns}; % minimum number of runs to analyze also the "winners" per function/image/dataset
    dlmcell(fname, parametersFile{1});
    fclose(fidParametersFile);
    
    StatisticalFramework
    
    fname = strcat('./statisticalTests/inputParameters.txt');
    fidParametersFile = fopen(fname, 'r+');
    parametersFile=textscan(fidParametersFile,'%s','delimiter','\n');
    parametersFile{1}(1) = {strcat(folder,fileResultsLocalizationCA,'.txt')}; % input file
    parametersFile{1}(2) = {localizationProblem}; % 0-> minimization problem, 1 -> maximization problem
    %     parametersFile{1}(4) = {'1'}; % number of benchmark functions -> in this case all images are considered as only one big image
    parametersFile{1}(3) = {significanceLevel};
    parametersFile{1}(4) = {NUMBER_OF_IMAGES}; % number of benchmark functions -> in this case every image is considered as a benchmark funct.
    parametersFile{1}(5) = {saveFigures};
    parametersFile{1}(6) = {strcat(folder,fileResultsLocalizationCA,'_output.txt')}; % output file
    parametersFile{1}(7) = {minimumAllowedNumberOfRuns}; % minimum number of runs to analyze also the "winners" per function/image/dataset
    dlmcell(fname, parametersFile{1});
    fclose(fidParametersFile);
    
    StatisticalFramework
end;

if performSegmentation==1
    %% Segmentation phase
    % First, create in globalResults folder the files with the values of
    % the metric to test
    matrixToPrint = [];
    label = '';
    for j=1:size(databaseOfMethods,2)
        if sum((strcmp(segmentationMethods,databaseOfMethods{j}) | strcmp(segmentationMethods,'all'))) > 0
            matrixToPrintTemp = [];
            for i=1:numberValues
                matrixToPrintTemp = [matrixToPrintTemp allResultsSegmentation{i}.(genvarname(databaseOfMethods{j})).(genvarname(char(metricToTest)))];
            end;
            matrixToPrint = [matrixToPrint matrixToPrintTemp'];
            label = strcat(label,strcat(char(databaseOfMethods{j})),',');
        end;
    end;
    fileID = fopen(strcat(folder,filesep,segmentationResultsFile,'_',char(metricToTest),'.txt'),'w');
    label(size(label,2))='';
    fprintf(fileID,'%s\n',label);
    fclose(fileID);
    dlmwrite(strcat(folder,filesep,segmentationResultsFile,'_',char(metricToTest),'.txt'), matrixToPrint, '-append', 'delimiter', ',');
    
    % Second, modify the inputParameters.txt file
    fname = strcat('.', filesep, 'statisticalTests', filesep,'inputParameters.txt');
    fidParametersFile = fopen(fname, 'r+');
    parametersFile=textscan(fidParametersFile,'%s','delimiter','\n');
    parametersFile{1}(1) = {strcat(folder,segmentationResultsFile,'_',char(metricToTest),'.txt')}; % input file
    parametersFile{1}(2) = {segmentationProblem}; % 0-> minimization problem, 1 -> maximization problem
    %     parametersFile{1}(4) = {'1'}; % number of benchmark functions -> in this case all images are considered as only one big image
    parametersFile{1}(3) = {significanceLevel};
    parametersFile{1}(4) = {NUMBER_OF_IMAGES}; % number of benchmark functions -> in this case every image is considered as a benchmark funct.
    parametersFile{1}(5) = {saveFigures};
    parametersFile{1}(6) = {strcat(folder,segmentationResultsFile,'_',char(metricToTest),'_output.txt')}; % output file
    parametersFile{1}(7) = {minimumAllowedNumberOfRuns}; % minimum number of runs to analyze also the "winners" per function/image/dataset
    dlmcell(fname, parametersFile{1});
    fclose(fidParametersFile);
    
    % Perform statistical tests
    StatisticalFramework
end;
