function [tout10, newmask, maskpoly, im, orig_im, im2] = ...
    segmentationIterativeOtsuThresholding(roi_points, roi_pointsdg, roi_points_out, roi_pointsdg_out, orig_im, ...
    area_to_select_ca_roi, area_to_select_dg_roi, radius_factor_ca_roi, SaveSegmentationEvolution, ...
    radius_factor_dg_roi, show_output, out_dir_name,image_name, REFERENCES,best_ref,timestamp)

tic
% figure
% cartesian coordinates of the final models
modelca = roi_points;
modeldg = roi_pointsdg;
modelcaout = roi_points_out;
modeldgout = roi_pointsdg_out;

%     orig_im = hip_img;
%orig_im = im;

% im2=adapthisteq(im2); Adaptive Histogram Equalization; the results were
% worst with this filtering -> much more oversegmentation (the global
% accuracy improved but with much more areas segmented)

% I have also tried with the median and enhancement filters inside the
% loop, applying them to tmp_im, but the results were much worst

% MEDIAN FILTER TO REMOVE THE 'SALT AND PEPPER' NOISE
im2=double(fast_medfilt(uint8(orig_im*255),12))/255.0; % im = medfilt2(im, [20 20],'symmetric');
%     im2=medfilt2(orig_im,[29 29]);

%     %             % This code would be used for seeing the result of applying
% %             % Otsu to all masks at the same time, and not iteratively
%     figure,imshow(im2);
%        modelca = ginput(11)
%    roi_points = modelca;
%    modelca_out = ginput(11)
%    modeldg = ginput(8)
%    roi_pointsdg = modeldg;
%    modeldg_out = ginput(8)

% ENHANCEMENT FILTER FOR KEEPING THE BOUNDARIES
H = fspecial('unsharp');
im = imfilter(im2,H,'replicate');

caWidth = (modelca(7,1) - modelcaout(7,1))*area_to_select_ca_roi; %how much area I want to select / 1.6 / 0.75
dgWidth = (modeldgout(7,2) - modeldg(7,2))*area_to_select_dg_roi; %aumenta questo numero per aumentare l'area / 1.6 /0.75

maskpoly = zeros(size(im));
%     maskborder = zeros(size(im));
%     expandme = zeros(size(im));
newmask = zeros(size(im));

if (show_output > 0)
    figure,
end;
savingNumberImage = 1;
for p=2:length(modelca)
    
    ca_maskpoly_circle = zeros(size(im));
    
    ca_segm = modelca(p,:) - modelca(p-1,:);
    [ca_segm(1) ca_segm(2)] = cart2pol(ca_segm(1),ca_segm(2));
    [ca_shift(1) ca_shift(2)]= pol2cart(ca_segm(1) + pi/2,caWidth);
    ca_mask = zeros(4,2);
    ca_mask(1,:) = [modelca(p-1,1)+ca_shift(1) modelca(p-1,2)+ca_shift(2)];
    ca_mask(2,:) = [modelca(p,1)+ca_shift(1) modelca(p,2)+ca_shift(2)];
    ca_mask(3,:) = [modelca(p,1)-ca_shift(1) modelca(p,2)-ca_shift(2)];
    ca_mask(4,:) = [modelca(p-1,1)-ca_shift(1) modelca(p-1,2)-ca_shift(2)];
    
    ca_maskpoly = poly2mask(ca_mask(:,1),ca_mask(:,2),size(im,1),size(im,2)); %now it is not used for segment, it's just for showing what i am working on
    %     figure,imshow(ca_maskpoly)
    
    % I'm creating small circular windows in the binding sites
    xys2= circle2([roi_points(p-1,1), roi_points(p-1,2)],caWidth/radius_factor_ca_roi,10);
    ca_maskpoly_circle = ca_maskpoly_circle + poly2mask(xys2(1,:),xys2(2,:),size(im,1),size(im,2));
    xys2 = circle2([roi_points(p,1), roi_points(p,2)],caWidth/radius_factor_ca_roi,10);
    ca_maskpoly_circle = ca_maskpoly_circle + poly2mask(xys2(1,:),xys2(2,:),size(im,1),size(im,2));
    %         figure,imshow(ca_maskpoly_circle)
    mask_temporal = ca_maskpoly + ca_maskpoly_circle;
    %         figure,imshow(mask_temporal)
    mask_temporal(mask_temporal>1)=1;
    tmp_im = im.*mask_temporal;
    %         figure,
    %         imshow(tmp_im);
    % %         figure,imshow(ca_maskpoly);
    % %         figure,imshow(ca_maskpoly_circle);
    %         waitforbuttonpress
    
    tmp_im(tmp_im==0) = 2; % all that's not mask will be white
    
    tmp_im = 1 - tmp_im; % inversion: the hippocampus will be the whitest part (the no hippocampus and the background will be black)
    
    level = graythresh(tmp_im(tmp_im>-1)); %if we use level = graythresh(tmp_im) the results will be much wider
    tmp_BW = im2bw(tmp_im,level);
    CC = bwconncomp(tmp_BW,8);
    numPixels = cellfun(@numel,CC.PixelIdxList);
    [biggest,idx] = max(numPixels);
    
    for i=1:length(numPixels)
        if i~=idx
            tmp_BW(CC.PixelIdxList{i}) = 0; %remove smaller connected components
        end
    end
    
    %         if classifyWindowTexture(orig_im,tmp_BW)
    newmask = newmask + tmp_BW;
    %         end;
    
    if SaveSegmentationEvolution==1
        % CODES TO SAVE THE IMAGES WITH THE EVOLUTION OF THE SEGMENTATION
        RGBnewmask = repmat(uint8(255.*newmask),[1 1 3]);
        RGBnewmask(:,:,3) = 0;
        RGBnewmask(:,:,2) = 0;
        RGBorig_im = repmat(uint8(255.*orig_im),[1 1 3]);
        index_find=find(RGBnewmask(:,:,1)==255 & RGBnewmask(:,:,2)==0 & RGBnewmask(:,:,3)==0);
        RGBorig_im(index_find) = 255;
        RGBorig_im(index_find+size(RGBorig_im,1)*size(RGBorig_im,2)) = 0;
        RGBorig_im(index_find+2*size(RGBorig_im,1)*size(RGBorig_im,2)) = 0;
        nameFileEvolutione = sprintf('%s/%s_IterOtsu_Evolution%d.png',out_dir_name,image_name, savingNumberImage);
        imwrite(RGBorig_im, nameFileEvolutione,'png');
        savingNumberImage = savingNumberImage + 1 ;
    end;
    
    %     subplot(1,3,1),imshow(tmp_im),subplot(1,3,2),imshow(tmp_BW),subplot(1,3,3),imshow(newmask);
    %     waitforbuttonpress
    
    maskpoly = maskpoly + ca_maskpoly + ca_maskpoly_circle;
    
    
    
end

for p=2:length(modeldg)
    
    dg_maskpoly_circle = zeros(size(im));
    
    dg_segm = modeldg(p,:) - modeldg(p-1,:);
    [dg_segm(1) dg_segm(2)] = cart2pol(dg_segm(1),dg_segm(2));
    [dg_shift(1) dg_shift(2)]= pol2cart(dg_segm(1) + pi/2,dgWidth);
    dg_mask = zeros(4,2);
    dg_mask(1,:) = [modeldg(p-1,1)+dg_shift(1) modeldg(p-1,2)+dg_shift(2)];
    dg_mask(2,:) = [modeldg(p,1)+dg_shift(1) modeldg(p,2)+dg_shift(2)];
    dg_mask(3,:) = [modeldg(p,1)-dg_shift(1) modeldg(p,2)-dg_shift(2)];
    dg_mask(4,:) = [modeldg(p-1,1)-dg_shift(1) modeldg(p-1,2)-dg_shift(2)];
    dg_maskpoly = poly2mask(dg_mask(:,1),dg_mask(:,2),size(im,1),size(im,2));
    
    % I'm creating small circular windows in the binding sites
    xys3= circle2([roi_pointsdg(p-1,1), roi_pointsdg(p-1,2)],dgWidth/radius_factor_dg_roi,10);
    dg_maskpoly_circle = dg_maskpoly_circle + poly2mask(xys3(1,:),xys3(2,:),size(im,1),size(im,2));
    xys3 = circle2([roi_pointsdg(p,1), roi_pointsdg(p,2)],dgWidth/radius_factor_dg_roi,10);
    dg_maskpoly_circle = dg_maskpoly_circle + poly2mask(xys3(1,:),xys3(2,:),size(im,1),size(im,2));
    mask_temporal = dg_maskpoly + dg_maskpoly_circle;
    mask_temporal(mask_temporal>1)=1;
    tmp_im = im.*mask_temporal;
    
    tmp_im(tmp_im==0) = 2;
    
    tmp_im = 1 - tmp_im;
    
    level = graythresh(tmp_im(tmp_im>-1));
    tmp_BW = im2bw(tmp_im,level);
    CC = bwconncomp(tmp_BW,8);
    numPixels = cellfun(@numel,CC.PixelIdxList);
    [biggest,idx] = max(numPixels);
    for i=1:length(numPixels)
        if i~=idx
            tmp_BW(CC.PixelIdxList{i}) = 0;
        end
    end
    
    %         if classifyWindowTexture(orig_im,tmp_BW)
    newmask = newmask + tmp_BW;
    %         end;
    
    %     subplot(1,3,1),imshow(tmp_im),subplot(1,3,2),imshow(tmp_BW),subplot(1,3,3),imshow(newmask);
    %     waitforbuttonpress
    
    if SaveSegmentationEvolution==1
        % CODES TO SAVE THE IMAGES WITH THE EVOLUTION OF THE SEGMENTATION
        RGBnewmask = repmat(uint8(255.*newmask),[1 1 3]);
        RGBnewmask(:,:,3) = 0;
        RGBnewmask(:,:,2) = 0;
        RGBorig_im = repmat(uint8(255.*orig_im),[1 1 3]);
        index_find=find(RGBnewmask(:,:,1)==255 & RGBnewmask(:,:,2)==0 & RGBnewmask(:,:,3)==0);
        RGBorig_im(index_find) = 255;
        RGBorig_im(index_find+size(RGBorig_im,1)*size(RGBorig_im,2)) = 0;
        RGBorig_im(index_find+2*size(RGBorig_im,1)*size(RGBorig_im,2)) = 0;
        nameFileEvolutione = sprintf('%s/%s_IterOtsu_Evolution%d.png',out_dir_name,image_name, savingNumberImage);
        imwrite(RGBorig_im, nameFileEvolutione,'png');
        savingNumberImage = savingNumberImage + 1 ;
    end;
    
    
    maskpoly = maskpoly + ca_maskpoly + ca_maskpoly_circle;
    maskpoly = maskpoly + dg_maskpoly + dg_maskpoly_circle;
    
end;

%             % This code would be used for seeing the result of applying
%             % Otsu to all masks at the same time, and not iteratively
%         maskpoly(maskpoly>1)=1;
%         new_image = im.*maskpoly;
%         new_image(new_image==0) = 2; % all that's not mask will be white
%         new_image = 1 - new_image;
%         level = graythresh(new_image(new_image>-1));
%         tmp_BW = im2bw(new_image,level);




im(~maskpoly) = 2;

newmask(newmask>1) = 1;
newmask = imfill(newmask,'holes');


tout10 = toc; % time: segmentation using ROIs

%     SE = strel('disk', 5, 0);
%     inner = imerode(newmask, SE);
%     outer = imdilate(newmask, SE);
%     maskborder = (inner ~= outer);
%     tmp = orig_im.*maskborder;
%     level = graythresh(orig_im(maskborder==1));
%     borders = im2bw(tmp,level);
%     borders(maskborder==0)=2;
%     borders = 1 - borders;
%     oldmask = newmask;
%     newmask = borders + inner;

if (show_output > 0)
    subplot(2,2,1)
    imshow(orig_im);
end;
%     if referenceToUse == 0
%         hippo_filename = sprintf('%s/%s_orig_im%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI
%     else
%         hippo_filename = sprintf('%s/%s_orig_im%d_%s.png',out_dir_name,image_name, referenceToUse,timestamp); %save extracted ROI
%     end;
%     imwrite(orig_im, hippo_filename,'png');

if (show_output > 0)
    subplot(2,2,2)
    imshow(im);
end;

hippo_filename = sprintf('%s/%s_im_IterOtsu_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(im, hippo_filename,'png');

if (show_output > 0)
    hold on
    line(modelca(:,1),modelca(:,2));
    line(modeldg(:,1),modeldg(:,2));
    hold off
    subplot(2,2,4)
    imshow(orig_im.*newmask);
end;

hippo_filename = sprintf('%s/%s_orig_im_newmask_IterOtsu_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(orig_im.*newmask, hippo_filename,'png');

if (show_output > 0)
    subplot(2,2,3)
    imshow(newmask);
end;
save(strcat(out_dir_name,'/',image_name,'_IterOtsu.mat'),'newmask');

hippo_filename = sprintf('%s/%s_newmask_IterOtsu_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(newmask, hippo_filename,'png');