function [tout19, newmask] = ...
    segmentationKM(orig_im, out_dir_name,image_name, REFERENCES,best_ref,timestamp)

%% K-MEANS: DETERMINISTIC METHOD

refinement = 0; 
% Fill holes & remove smallest connected components. It's important to
% notice that this is an improvement that it's not part of the K-Means
% algorithm, so maybe it's better not to use it.

tic

k=2;
originalSize= size(orig_im);
orig_im2 = imresize(orig_im,[1000 1000]);

ima=im2uint8(orig_im2);
ima = double(ima);
copy=ima;         % make a copy
ima=ima(:);       % vectorize ima
mi=min(ima);      % deal with negative
ima=ima-mi+1;     % and zero values --> in this way always the histogram
% of the image will start from 1 (easy to manage the creation of centroids)

s=length(ima);

% create image histogram
m=max(ima)+1;
h=zeros(1,m);
hc=zeros(1,m);

for i=1:s
    if(ima(i)>0) h(ima(i))=h(ima(i))+1;end;
end
ind=find(h);
hl=length(ind);
% plot(h) or figure,hist(ima)

% initiate centroids: dividing in three parts the histogram (every threshold would be a centroid)
mu=(1:k)*m/(k+1);


% start process
while(true)
    
    oldmu=mu;
    % current classification
    
    for i=1:hl
        c=abs(ind(i)-mu);
        cc=find(c==min(c));
        hc(ind(i))=cc(1);
    end
    
    %recalculation of means
    
    for i=1:k,
        a=find(hc==i);
        mu(i)=sum(a.*h(a))/sum(h(a));
    end
    
%     kkk = im2uint8(orig_im2);
%     kkk_soglia = sum(mu)/2;
%     
%     kkk(kkk<=kkk_soglia) = 0;
%     kkk(kkk>kkk_soglia) = 255;
%     
%     figure,imshow(kkk)
    
    if(mu==oldmu) break;end;
    
end

% calculate mask
s=size(copy);
mask=zeros(s);
for i=1:s(1),
    for j=1:s(2),
        c=abs(copy(i,j)-mu);
        a=find(c==min(c));
        mask(i,j)=a(1);
    end
end

mu=mu+mi-1;   % recover real range

mask(mask==1)=255;
mask(mask==2)=0;

outputImage = imresize(mask, originalSize);
% outputImage = mask;
outputImage(outputImage>0)=255;
outputImage(outputImage==255)=1;

if refinement
    outputImage = imfill(outputImage,'holes');    
    outputImage2 = zeros(size(outputImage));    
    CC = bwconncomp(outputImage,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
    numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
    [ordered,idx] = sort(numPixels,'descend');
    ordered(ordered < 5000) = 0;
    % con_component=2; %minimum number of con_components
    for c=1:size(idx,2)%con_component
        if (ordered(c)) ~= 0
            outputImage2(CC.PixelIdxList{idx(c)}) = 1;
        end;
    end
    
    % CC = bwconncomp(mask,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
    % numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
    % [ordered,idx] = sort(numPixels,'descend');
    % con_component=2; %minimum number of con_components
    % for c=1:con_component
    %     outputImage2(CC.PixelIdxList{idx(c)}) = 1;
    % end
    
    newmask = outputImage2;
    
else
    newmask = outputImage;
end;

tout19 = toc; % time: segmentation K-Means

save(strcat(out_dir_name,'/',image_name,'_KM.mat'),'newmask');

hippo_filename = sprintf('%s/%s_orig_im_newmask_KM_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(orig_im.*newmask, hippo_filename,'png');

save(strcat(out_dir_name,'/',image_name,'_KM.mat'),'newmask');

hippo_filename = sprintf('%s/%s_newmask_KM_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(newmask, hippo_filename,'png');

