function [tout15, newmask] = ...
    segmentationOtsu(orig_im, out_dir_name,image_name, REFERENCES,best_ref,timestamp)

%% OTSU THRESHOLDING METHOD: DETERMINISTIC METHOD

refinement = 1;
% Fill holes & remove smallest connected components. It's important to
% notice that this is an improvement that it's not part of the K-Means
% algorithm, so maybe it's better not to use it.

tic

originalSize= size(orig_im);
orig_im2 = imresize(orig_im,[1000 1000]);
%         orig_im2 = medfilt2(orig_im2, [10 10]);

th_level = graythresh(orig_im2);
tmp_roi = 1-im2bw(orig_im2,th_level);

% tmp_roi = tmp_roi/255;

outputImage = imresize(tmp_roi, originalSize);
% outputImage = mask;
outputImage(outputImage>0)=255;
outputImage(outputImage==255)=1;

tmp_roi = outputImage;

if refinement
    outputImage = medfilt2(tmp_roi,[15 15]);
%     outputImage = imfill(tmp_roi,'holes');    %tmp_roi;
    outputImage2 = zeros(size(tmp_roi));
    
    % CC = bwconncomp(outputImage2,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
    % numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
    % [ordered,idx] = sort(numPixels,'descend');
    % con_component=2; %minimum number of con_components
    % for c=1:con_component
    %     outputImage(CC.PixelIdxList{idx(c)}) = 1;
    % end
    
    CC = bwconncomp(outputImage,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
    numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
    [ordered,idx] = sort(numPixels,'descend');
    ordered(ordered < 5000) = 0;
    % con_component=2; %minimum number of con_components
    for c=1:size(idx,2)%con_component
        if (ordered(c)) ~= 0
            outputImage2(CC.PixelIdxList{idx(c)}) = 1;
        end;
    end
    newmask = outputImage2;    
else
    newmask = tmp_roi;    
end;

tout15 = toc; % time: segmentation otsu

%%   SAVE IMAGES
save(strcat(out_dir_name,'/',image_name,'_Otsu.mat'),'newmask');

hippo_filename = sprintf('%s/%s_orig_im_newmask_Otsu_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(orig_im.*newmask, hippo_filename,'png');

hippo_filename = sprintf('%s/%s_newmask_Otsu_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(newmask, hippo_filename,'png');

