function [tout7, tout8, modelca, modeldg, modelca_out, modeldg_out, finalModelDG, finalModelCA, individualResults, ...
    roi_points, roi_pointsdg, roi_points_out, roi_pointsdg_out,n_points, n_points_dg] = ...
    structureLocalization(n_points_dg, show_output, N_MAX_TEST_MODEL, ...
    referenceToUse, REFERENCES, modelsToUse, PENALTIES_DG, PENALTIES_CA,image_side, ...
    LOCAL_SEARCH_SIZE, ERROR_DG, ERROR_CA, fitn_sort,target,metaheuristic,metaheuristicRuns,individualResults, ...
    out_dir_name, image_name, timestamp, best_ref, hip_img, output_hippo_bound, generations, populationSize)



tic
%% DG LOCALIZATION
if show_output > 0
    fprintf(1,'Dentate Gyrus Localization.\n');
end

% model = zeros(n_points_dg,2); %it will contain the cartesian coordinates of the points
% movements_cart = zeros(size(model)); %it will contain the cartesian coordinates of the shifts

n_m = 1;
best_dg_error = 5*n_points_dg + 20*(n_points_dg-1);
dg_error = best_dg_error;
% individualResults.fitnessValuesDE_DG=[];
% individualResults.fitnessValuesPSO_DG=[];
% individualResults.fitnessValuesSS_DG=[];
% individualResults.fitnessValuesSA_DG=[];
% individualResults.fitnessValuesGA_DG=[];

if referenceToUse ~= 0
    REFERENCES2 = zeros(1,N_MAX_TEST_MODEL);
    REFERENCES2(1) = referenceToUse;
    limitReachedMax=0;
    limitReachedMin=0;
    if referenceToUse == REFERENCES(1)
        for i=2:N_MAX_TEST_MODEL
            REFERENCES2(i) = referenceToUse + (i-1);
        end;
    elseif referenceToUse == REFERENCES(size(REFERENCES,1))
        for i=2:N_MAX_TEST_MODEL
            REFERENCES2(i) = referenceToUse - (i-1);
        end;
    else
        j=1;
        for i=2:N_MAX_TEST_MODEL
            if ((mod(i,2)==0) & (limitReachedMax==0) | (mod(i,2)==0) & (limitReachedMin==1))
                REFERENCES2(i) = referenceToUse + j;
                if ~ismember(REFERENCES2(i),REFERENCES)
                    REFERENCES2(i) = referenceToUse - j;
                    j=j+1;
                    limitReachedMax = 1;
                end;
            else
                REFERENCES2(i) = referenceToUse - j;
                if ~ismember(REFERENCES2(i),REFERENCES)
                    j=j+1;
                    REFERENCES2(i) = referenceToUse + j;
                    limitReachedMin = 1;
                end;
                j=j+1;
            end;
        end;
    end;
end;


while dg_error > ERROR_DG && n_m <= N_MAX_TEST_MODEL %it should be a do-while
    if referenceToUse == 0
        model_used = REFERENCES(fitn_sort(n_m));
        finalModelDG = model_used;
    else
        model_used = REFERENCES2(n_m);
        %         model_used = referenceToUse;
        finalModelDG = model_used;
    end;
    if show_output > 0
        fprintf(1,'Using model %d\n', model_used);
    end
    
    switch modelsToUse
        case 'classical'
            [movements_min movements_max movements_mean outer_shift] = get_modelsOld(model_used,1);
            n_points_dg=7;
            %S_struct.I_D   = n_points_dg*2;
            model = zeros(n_points_dg,2); %it will contain the cartesian coordinates of the points
            movements_cart = zeros(size(model)); %it will contain the cartesian coordinates of the shifts
        case 'morePoints'
            [movements_min movements_max movements_mean outer_shift n_points_dg] = get_models_new(model_used,1);
            %S_struct.I_D   = n_points_dg*2;
            %S_struct.F_VTR = -(5*n_points_dg + 20*(n_points_dg-1));
            model = zeros(n_points_dg,2); %it will contain the cartesian coordinates of the points
            movements_cart = zeros(size(model)); %it will contain the cartesian coordinates of the shifts
        case 'ASC' % larger points only over 15 images -> more specific models fitted to these images
            [movements_min movements_max movements_mean outer_shift n_points_dg] = get_synth_models(image_name,1,model_used);
    end
    
    outer_shift_cart = zeros(n_points_dg,2);
    [outer_shift_cart(:,1) outer_shift_cart(:,2)] = pol2cart(outer_shift(:,1),outer_shift(:,2));
    
    outer_shift_cart_op = ceil(reshape(outer_shift_cart',n_points_dg*2,1));
    % Why ceil? The results sometimes are strange (0.0000 -> 1 because it's 0.000000000000003 and ceil round towards plus infinity)
    % This
    %    0.0000 -50.0000 35.3553 -35.3553 35.3553 -35.3553 60.0000 0      35.3553 35.3553 35.3553 35.3553 0.0000 50.0000
    % is converted into this:
    %    1      -50      36      -35      36      -35      60      0      36      36      36      36      1      50
    % Try with round
    
    %     %     de_find(0,target,outer_shift_cart_op,movements_min, movements_max, movements_mean, PENALTIES_DG);%[27 0.055 1]);
    %     %     [xmin,tfxmin]=deopt('deopt_find_mask',S_struct);
    
    for runs=1:metaheuristicRuns
        if sum(strcmpi(metaheuristic,'DE'))~=0
            [xmin, tfxmin] = optimizationWithDE(show_output, n_points_dg, ...
                target, outer_shift_cart_op,movements_min, movements_max, movements_mean, PENALTIES_DG, generations, populationSize);
            if n_m==1
                individualResults.localizationDG.fitnessDE = [individualResults.localizationDG.fitnessDE, tfxmin];
            end;
        elseif sum(strcmpi(metaheuristic,'GA'))~=0
            [xmin,tfxmin] = optimizationWithGA(n_points_dg, ...
                target, outer_shift_cart_op, movements_min, movements_max, movements_mean, PENALTIES_DG, generations, populationSize);
            if n_m==1
                individualResults.localizationDG.fitnessGA = [individualResults.localizationDG.fitnessGA, tfxmin];
            end;
        elseif sum(strcmpi(metaheuristic,'SA'))~=0
            [xmin,tfxmin] = optimizationWithSA(n_points_dg, ...
                target, outer_shift_cart_op, movements_min, movements_max, movements_mean, PENALTIES_DG, generations, populationSize);
            if n_m==1
                individualResults.localizationDG.fitnessSA = [individualResults.localizationDG.fitnessSA, tfxmin];
            end;
        elseif sum(strcmpi(metaheuristic,'SS'))~=0
            [xmin,tfxmin] = optimizationWithSS(n_points_dg, ...
                target, outer_shift_cart_op, movements_min, movements_max, movements_mean, PENALTIES_DG, generations, populationSize);
            if n_m==1
                individualResults.localizationDG.fitnessSS = [individualResults.localizationDG.fitnessSS, tfxmin];
            end;
        elseif sum(strcmpi(metaheuristic,'PSO'))~=0
            [xmin,tfxmin] = optimizationWithPSO(n_points_dg, ...
                target, outer_shift_cart_op, movements_min, movements_max, movements_mean, PENALTIES_DG, generations, populationSize);
            if n_m==1
                individualResults.localizationDG.fitnessPSO = [individualResults.localizationDG.fitnessPSO, tfxmin];
            end;
        end;
    end;
    
    model = zeros(n_points_dg,2); %it will contain the cartesian coordinates of the points
    movements_cart = zeros(size(model)); %it will contain the cartesian coordinates of the shifts
    
    xmin = xmin.*(movements_max-movements_min)+movements_min;
    xmin = reshape(xmin,n_points_dg,2);
    [movements_cart(:,1) movements_cart(:,2)] = pol2cart(xmin(:,1),xmin(:,2));
    model(1,:) = ceil(movements_cart(1,:));
    for i=2:size(model,1) %obtain points from the shifts
        model(i,:) = model(i-1,:) + ceil(movements_cart(i,:));
    end
    model(model<1)=1; model(model>image_side)=image_side; %if the points are outside
    model_out = model + ceil(outer_shift_cart);
    model_out(model_out<1)=1; model_out(model_out>image_side)=image_side;
    
    %PROVA RICERCA LOCALE, metodo esaustivo
    best_fitn = tfxmin;
    changes = zeros(n_points_dg,2);
    for i=1:n_points_dg %for every point try in a neighbourhood
        test_model = model;% + changes;
        %         movements_cart2 = movements_cart;
        for j=-LOCAL_SEARCH_SIZE:LOCAL_SEARCH_SIZE
            for k=-LOCAL_SEARCH_SIZE:LOCAL_SEARCH_SIZE
                test_model(i,1) = model(i,1)+j;
                test_model(i,2) = model(i,2)+k;
                test_model(test_model>image_side) = image_side; test_model(test_model<1) = 1;
                test_model_out = test_model + ceil(outer_shift_cart);
                test_model_out(test_model_out>image_side) = image_side; test_model_out(test_model_out<1) = 1;
                act_fitn = pso_hippo_fitness([test_model; test_model_out], target, reshape(movements_mean,n_points_dg-1,2),PENALTIES_DG);
                
                %                                 figure,subplot(1,2,1),imshow(target)
                %                                 hold on
                %                                 plot(test_model(:,1),test_model(:,2),'r*')
                %                                 plot(test_model_out(:,1),test_model_out(:,2),'bv')
                %                                 subplot(1,2,2),imshow(target)
                %                                 hold on
                %                                 plot(model(:,1),model(:,2),'r*')
                %                                 plot(model_out(:,1),model_out(:,2),'bv')
                if act_fitn < best_fitn
                    best_fitn = act_fitn;
                    changes(i,1) = j;
                    changes(i,2) = k;
                end
            end
        end
    end
    model = model + changes; %update position
    model_out = model_out + changes;
    model_out(model_out>image_side) = image_side; model_out(model_out<1) = 1;
    dg_error = 5*n_points_dg + 20*(n_points_dg-1) + pso_hippo_fitness([model; model_out], target, reshape(movements_mean,n_points_dg-1,2),[0 0 0]);
    if show_output > 0
        fprintf(1,'DG Displacement: %f\n',dg_error);
    end
    if dg_error < best_dg_error
        modeldg = model;
        modeldg_out = model_out;
        best_dg_error = dg_error;
        finalModelDG = model_used;
    end
    n_m = n_m + 1;
    
end %while
tout7 = toc; %time: dg localization

if show_output > 2
    figure('Name','Hippocampus on ROI','NumberTitle','off');
    imshow(target);
    hold on
    line(modeldg(:,1),modeldg(:,2),'Color','r','LineWidth',4);
    line(modeldg_out(:,1),modeldg_out(:,2),'Color','g','LineWidth',2);
end

f = figure('Name','Hippocampus on ROI','NumberTitle','off','Visible','off');
imshow(target);
hold on
line(modeldg(:,1),modeldg(:,2),'Color','r','LineWidth',4);
line(modeldg_out(:,1),modeldg_out(:,2),'Color','g','LineWidth',2);




tic
%% CA LOCALIZATION
%%The localization of CA is quite independent from DG, in the sense of we
%%can have DG localized using the model 32 and CA localized using the 40.
if show_output > 0
    fprintf(1,'Ammon''s Horn Localization.\n');
end
if referenceToUse == 0
    model_used = REFERENCES(fitn_sort(1));
    finalModelCA = model_used;
else
    model_used = REFERENCES2(1);
    %         model_used = referenceToUse;
    finalModelCA = model_used;
end;
% model_used = REFERENCES(fitn_sort(1));

switch modelsToUse
    case 'classical'
        [movements_min] = get_modelsOld(model_used,2);
    case 'morePoints'
        [movements_min] = get_models_new(model_used,2);
    case 'ASC' % larger points only over 15 images -> more specific models fitted to these images
        [movements_min] = get_synth_models(image_name,2, model_used);
end

n_points = size(movements_min,2)/2;

% %change differential evolution params for CA
% S_struct.I_D   = n_points*2;
% S_struct.F_VTR = -(5*n_points + 20*(n_points-1));

best_ca_error = 5*n_points + 20*(n_points-1);
ca_error = best_ca_error;
n_m = 1; %index of model to try
% individualResults.fitnessValuesDE_CA=[];
% individualResults.fitnessValuesPSO_CA=[];
% individualResults.fitnessValuesSS_CA=[];
% individualResults.fitnessValuesSA_CA=[];
% individualResults.fitnessValuesGA_CA=[];
while ca_error > ERROR_CA && n_m <= N_MAX_TEST_MODEL %it should be a do-while
    if referenceToUse == 0
        model_used = REFERENCES(fitn_sort(n_m));
    else
        model_used = REFERENCES2(n_m);
        %         model_used = referenceToUse;
    end;
    if show_output > 0
        fprintf(1,'Using model %d\n', model_used);
    end
    
    switch modelsToUse
        case 'classical'
            [movements_min movements_max movements_mean outer_shift] = get_modelsOld(model_used,2);
        case 'morePoints'
            [movements_min movements_max movements_mean outer_shift] = get_models_new(model_used,2);
            n_points = size(movements_min,2)/2;
            %             S_struct.I_D   = n_points*2;
            %             S_struct.F_VTR = -(5*n_points + 20*(n_points-1));
        case 'ASC' % larger points only over 15 images -> more specific models fitted to these images
            [movements_min movements_max movements_mean outer_shift n_points] = get_synth_models(image_name,2, model_used);
    end
    
    outer_shift_cart = zeros(n_points,2);
    [outer_shift_cart(:,1) outer_shift_cart(:,2)] = pol2cart(outer_shift(:,1),outer_shift(:,2));
    
    % una vez localizado SG/DG tenemos que localizar CA/SP. Multiplicamos
    % por 1.1 y por 0.9 para buscar un poquito antes y despues en el
    % espacio. Es un modo de restringir el espacio de busqueda.
    % movements_max(1) y movements_max(n_points+1) estan relacionados con
    % el cuarto punto, es decir, la curva de SG, la esquina, es la que
    % determina el limite de busqueda. Por lo tanto, el primer punto a
    % buscar de SP/CA tiene va a tener un menor angulo maximo de busqueda
    % porque ya hemos fijado la otra estructura, asi como un mayor angulo
    % minimo, y la longitud maxima aumenta.
    %change the possible starting position of CA model based on DG model results
    [movements_max(1) movements_max(n_points+1)] = cart2pol(modeldg(4,1),modeldg(4,2));%this part is above the other
    movements_max(n_points+1) =  movements_max(n_points+1)*1.1; %start position vector module
    movements_max(1) =  movements_max(1)*0.9; %it can not start from the very same point
    movements_min(1) =  max([movements_max(1)-0.314 movements_min(1)]);
    
    %%% It seems that now it's not necessary with the new models
    % let the maximum lenghts of the model to be bigger
    %     movements_max(10:16) = movements_max(10:16)*factorIncreasingLengthCA;
    
    outer_shift_cart_op = ceil(reshape(outer_shift_cart',n_points*2,1));
    
    for runs=1:metaheuristicRuns
        if sum(strcmpi(metaheuristic,'DE'))~=0
            [xmin, tfxmin] = optimizationWithDE(show_output, n_points, target, ...
                outer_shift_cart_op,movements_min, movements_max, movements_mean, PENALTIES_CA, generations, populationSize);
            if n_m==1
                individualResults.localizationCA.fitnessDE = [individualResults.localizationCA.fitnessDE, tfxmin];
            end;
        elseif sum(strcmpi(metaheuristic,'GA'))~=0
            [xmin,tfxmin] = optimizationWithGA(n_points, ...
                target, outer_shift_cart_op, movements_min, movements_max, movements_mean, PENALTIES_CA, generations, populationSize);
            if n_m==1
                individualResults.localizationCA.fitnessGA = [individualResults.localizationCA.fitnessGA, tfxmin];
            end;
        elseif sum(strcmpi(metaheuristic,'SA'))~=0
            [xmin,tfxmin] = optimizationWithSA(n_points, ...
                target, outer_shift_cart_op, movements_min, movements_max, movements_mean, PENALTIES_CA, generations, populationSize);
            individualResults.localizationCA.fitnessSA = [individualResults.localizationCA.fitnessSA, tfxmin];
        elseif sum(strcmpi(metaheuristic,'SS'))~=0
            [xmin,tfxmin] = optimizationWithSS(n_points, ...
                target, outer_shift_cart_op, movements_min, movements_max, movements_mean, PENALTIES_CA, generations, populationSize);
            if n_m==1
                individualResults.localizationCA.fitnessSS = [individualResults.localizationCA.fitnessSS, tfxmin];
            end;
        elseif sum(strcmpi(metaheuristic,'PSO'))~=0
            [xmin,tfxmin] = optimizationWithPSO(n_points, ...
                target, outer_shift_cart_op, movements_min, movements_max, movements_mean, PENALTIES_CA, generations, populationSize);
            if n_m==1
                individualResults.localizationCA.fitnessPSO = [individualResults.localizationCA.fitnessPSO, tfxmin];
            end;
        end;
    end;
    
    %     de_find(0,target,outer_shift_cart_op,movements_min, movements_max, movements_mean, PENALTIES_CA);%[27 0.055 1]);
    %     [xmin,tfxmin]=deopt('deopt_find_mask',S_struct);
    model = zeros(n_points,2);
    movements_cart = zeros(size(model));
    xmin = xmin.*(movements_max-movements_min)+movements_min;
    xmin = reshape(xmin, n_points,2);
    [movements_cart(:,1) movements_cart(:,2)] = pol2cart(xmin(:,1),xmin(:,2));
    model(1,:) = ceil(movements_cart(1,:));
    for i=2:size(model,1)
        model(i,:) = model(i-1,:) + ceil(movements_cart(i,:));
    end
    model(model<1)=1; model(model>image_side)=image_side;
    model_out = model + ceil(outer_shift_cart);
    model_out(model_out<1)=1; model_out(model_out>image_side)=image_side;
    
    % xminca = xmin;
    
    %PROVA RICERCA LOCALE, metodo esaustivo
    best_fitn = tfxmin;
    changes = zeros(n_points,2);
    for i=1:n_points
        test_model = model;% + changes;
        for j=-LOCAL_SEARCH_SIZE:LOCAL_SEARCH_SIZE
            for k=-LOCAL_SEARCH_SIZE:LOCAL_SEARCH_SIZE
                test_model(i,1) = model(i,1)+j;
                test_model(i,2) = model(i,2)+k;
                test_model(test_model<1) = 1;test_model(test_model>image_side) = image_side;
                test_model_out = test_model + ceil(outer_shift_cart);
                test_model_out(test_model_out>image_side) = image_side; test_model_out(test_model_out<1) = 1;
                act_fitn = pso_hippo_fitness([test_model; test_model_out], target, reshape(movements_mean,n_points-1,2),PENALTIES_CA);
                if act_fitn < best_fitn
                    best_fitn = act_fitn;
                    changes(i,1) = j;
                    changes(i,2) = k;
                end
            end
        end
    end
    model = model + changes;
    model_out = model_out + changes;
    model_out(model_out>image_side) = image_side; model_out(model_out<1) = 1;
    ca_error = 5*n_points + 20*(n_points-1) + pso_hippo_fitness([model; model_out], target, reshape(movements_mean,n_points-1,2),[0 0 0]); % here i want to see only how many points are outside their positions, i don't care about distortion
    if show_output > 0
        fprintf(1,'CA Displacement: %f\n',ca_error);
    end
    if ca_error < best_ca_error
        modelca = model;
        modelca_out = model_out;
        best_ca_error = ca_error;
        finalModelCA = model_used;
    end
    n_m = n_m + 1;
    
end %while
tout8 = toc; %time: ca localization

if show_output > 2
    line(modelca(:,1),modelca(:,2),'Color','r','LineWidth',4);
    line(modelca_out(:,1),modelca_out(:,2),'Color','g','LineWidth',2);
end

line(modelca(:,1),modelca(:,2),'Color','r','LineWidth',4);
line(modelca_out(:,1),modelca_out(:,2),'Color','g','LineWidth',2);
tmp_filename = sprintf('%s/%s_localization_%s_%d_%s.png',out_dir_name,image_name, char(metaheuristic),REFERENCES(best_ref), timestamp);
print(f, '-r80', '-dpng', tmp_filename);
% print(f, '-r80', '-dpng',strcat('localization_',char(metaheuristic),'.png'));



% to print the final model over the original image
%if strcmp(modelsToUse,'morePoints')
if (strcmp(modelsToUse,'morePoints') | strcmp(modelsToUse,'ASC'))
    n_points = length(modelca);
    n_points_dg = length(modeldg);
end;
ratio = size(hip_img)./size(target);
ratio = [ratio(2) ratio(1)];
roi_points = ceil(repmat(ratio,n_points,1).*modelca);
roi_pointsdg = ceil(repmat(ratio,n_points_dg,1).*modeldg);
roi_points_out = ceil(repmat(ratio,n_points,1).*modelca_out);
roi_pointsdg_out = ceil(repmat(ratio,n_points_dg,1).*modeldg_out);
xmin = min([roi_pointsdg_out(:,1); roi_points_out(:,1); roi_pointsdg(:,1); roi_points(:,1)])-output_hippo_bound;
ymin = min([roi_pointsdg_out(:,2); roi_points_out(:,2); roi_pointsdg(:,2); roi_points(:,2)])-output_hippo_bound;
w = max([roi_pointsdg_out(:,1); roi_points_out(:,1); roi_pointsdg(:,1); roi_points(:,1)]) - xmin+output_hippo_bound*2;
h = max([roi_pointsdg_out(:,2); roi_points_out(:,2); roi_pointsdg(:,2); roi_points(:,2)]) - ymin+output_hippo_bound*2;

h = figure('Name','Hippocampus Localization','NumberTitle','off','Visible','off');
imshow(hip_img)
hold on
line(roi_points(:,1),roi_points(:,2),'Color','y','LineWidth',4);
line(roi_pointsdg(:,1),roi_pointsdg(:,2),'Color','r','LineWidth',4);
hold on, plot(roi_points(:,1),roi_points(:,2),'r*')
hold on, plot(roi_pointsdg(:,1),roi_pointsdg(:,2),'y*')
line(roi_points_out(:,1),roi_points_out(:,2),'Color','y','LineWidth',3,'LineStyle',':');
line(roi_pointsdg_out(:,1),roi_pointsdg_out(:,2),'Color','r','LineWidth',3,'LineStyle',':');
tmp_filename = sprintf('%s/%s_OverRealImage_%s_ref%d_%s.png',out_dir_name,image_name, char(metaheuristic),REFERENCES(best_ref), timestamp);
saveas(h,tmp_filename,'png');


